// --- file lib/LIBFILES/Mambo.mu ---
// Mambo -- the Mambo toolbox

Mambo := newDomain("Mambo"):

Mambo::Name := "Mambo":
Mambo::info := "Library 'Mambo': the Mambo toolbox":

Mambo::interface := {
hold(AngularMomentum),
hold(AngularVelocity),
hold(CoeffExtract),
hold(DeclareObservers),
hold(DeclarePoints),
hold(DeclareStates),
hold(DeclareTriads),
hold(DefineNeighbors),
hold(DefineObjects),
hold(DefineObservers),
hold(DefinePoints),
hold(DefineTriads),
hold(DiffTime),
hold(Express),
hold(FindCoordinates),
hold(FindOrientation),
hold(FindPosition),
hold(FindRotation),
hold(FindTranslation),
hold(ForceDescription),
hold(GeometryOutput),
hold(LinearMomentum),
hold(LinearVelocity),
hold(MakeDescription),
hold(MakeRotations),
hold(MakeTranslations),
hold(MomentumDescription),
hold(MotionOutput),
hold(NullVector),
hold(Restart),
hold(MamboSimplify),
hold(Undo),
hold(VectorLength),
hold(VelocityDescription)}:

MamboVector := newDomain("MamboVector"):
MamboVector::new := proc() begin new(dom,args()) end_proc:
MamboVector::print := proc(x) begin op(x) end_proc:
MamboVector::_index := proc(x,i) begin op(x,1)[i] end_proc:
MamboDescription := newDomain("MamboDescription"):
MamboDescription::new := proc() begin new(dom,args()) end_proc:
MamboDescription::print := proc(x) begin op(x) end_proc:
MamboDescription::_index := proc(x,i,j) begin if not testtype(i,DOM_INT) then op(x,1)[i]; else op(x,1)[i,j]; end_if end_proc:

// defining the methods

// suggested name conventions for files: directories in CAPITALS,
// file names match the names of functions (including case) defined in them.
// When following these conventions, you can use the simple autoload
// command. E.g., numfuns::factorial is defined in NUMFUNS/factorial.mu:

autoload(Mambo::_DefineNeighbor):
autoload(Mambo::_DefineObject):
autoload(Mambo::MakeDescription):
autoload(Mambo::_MakeRotation):
autoload(Mambo::_MakeTranslation):
autoload(Mambo::_NullDescription):
autoload(Mambo::AngularMomentum):
autoload(Mambo::AngularVelocity):
autoload(Mambo::Backup):
autoload(Mambo::CheckArguments):
autoload(Mambo::ClearZero):
autoload(Mambo::CoeffExtract):
autoload(Mambo::DeclareName):
autoload(Mambo::DeclareObservers):
autoload(Mambo::DeclarePoints):
autoload(Mambo::DeclareStates):
autoload(Mambo::DeclareTriads):
autoload(Mambo::DefineName):
autoload(Mambo::DefineNeighbors):
autoload(Mambo::DefineObjects):
autoload(Mambo::DefineObservers):
autoload(Mambo::DefinePoints):
autoload(Mambo::DefineTriads):
autoload(Mambo::DiffTime):
autoload(Mambo::DoIndent):
autoload(Mambo::Express):
autoload(Mambo::FindCoordinates):
autoload(Mambo::FindOrientation):
autoload(Mambo::FindPath):
autoload(Mambo::FindPosition):
autoload(Mambo::FindRotation):
autoload(Mambo::FindTranslation):
autoload(Mambo::ForceDescription):
autoload(Mambo::GeometryOutput):
autoload(Mambo::GeomOut):
autoload(Mambo::InEq):
autoload(Mambo::IsDeclared):
autoload(Mambo::IsDefined):
autoload(Mambo::LinearMomentum):
autoload(Mambo::LinearVelocity):
autoload(Mambo::MakeRotations):
autoload(Mambo::MakeTranslations):
autoload(Mambo::MamboCross):
autoload(Mambo::MamboDot):
autoload(Mambo::MamboMinus):
autoload(Mambo::MamboMult):
autoload(Mambo::MamboPlus):
autoload(Mambo::MamboSimplify):
autoload(Mambo::MomentumDescription):
autoload(Mambo::MotionOutput):
autoload(Mambo::NullVector):
autoload(Mambo::ObjectOutput):
autoload(Mambo::OrientOut):
autoload(Mambo::PointOut):
autoload(Mambo::Restart):
autoload(Mambo::Undo):
autoload(Mambo::VectorLength):
autoload(Mambo::VelocityDescription):

operator("&++",Mambo::MamboPlus,Binary,1300,Global);
operator("&**",Mambo::MamboMult,Binary,1305,Global);
operator("&--",Mambo::MamboMinus,Binary,1300,Global);
operator("&oo",Mambo::MamboDot,Binary,1310,Global);
operator("&xx",Mambo::MamboCross,Binary,1310,Global);
operator("&<",(x,y)->MamboLT(x,y),Binary,1250,Global);
operator("&<=",(x,y)->MamboLTE(x,y),Binary,1250,Global);
operator("&>",(x,y)->MamboGT(x,y),Binary,1250,Global);
operator("&>=",(x,y)->MamboGTE(x,y),Binary,1250,Global);
operator("&==",(x,y)->MamboE(x,y),Binary,1250,Global);
operator("&!=",(x,y)->MamboNE(x,y),Binary,1250,Global);