Mambo::AngularMomentum:=proc(observer:DOM_IDENT,triad:DOM_IDENT)
  local local_ev,reftriad,i,inertia;
  begin
    if args(0)=3 then
      if not testtype(args(3),matrix) then error("Improperly defined inertia matrix!");
      else inertia:=args(3);
      end_if;
    else inertia:=matrix(3,3,(i,j)->Inertia.i.j);
    end_if;
    if not Mambo::IsDefined(observer,`Observer`) then error("Observer not defined! ".observer);
    else
      reftriad:=GlobalObserverDefinitions[observer]["Triad"];
      local_ev:=op(Mambo::AngularVelocity(reftriad,triad));
      for i from 1 to local_ev["Size"] do
        local_ev[i]["Coordinates"]:=Mambo::FindRotation(local_ev[i]["Triad"],triad)*
          inertia*Mambo::FindRotation(triad,local_ev[i]["Triad"])*
            local_ev[i]["Coordinates"];
      end_for;
    end_if;
    return(MamboVector(local_ev));
  end_proc: