Mambo::AngularVelocity:=proc(triad1:DOM_IDENT,triad2:DOM_IDENT)
  local path,conn,rotation,angvelop;
  begin
    if not contains(GlobalAngularVelocity,triad1,triad2) then
      path:=Mambo::FindPath(triad1,triad2,GlobalTriadDeclarations);
      if nops(path)=0 then
        error("No path exists between the triads! ".triad1." ".triad2)
      elif nops(path)=1 then
        GlobalAngularVelocity[triad1][triad2]:=NullVector();
      elif nops(path)=2 then
        rotation:=Mambo::FindRotation(triad1,triad2);
        angvelop:=transpose(rotation)*Mambo::DiffTime(rotation);
        return(Mambo::MamboSimplify(Mambo::_MakeTranslation(triad2,angvelop[3,2],angvelop[1,3],angvelop[2,1])));
      else
        for conn from 2 to nops(path) do
          if not contains(GlobalAngularVelocity,triad1,path[conn]) then
            GlobalAngularVelocity[triad1][path[conn]]:=Mambo::MamboPlus(Mambo::AngularVelocity(triad1,path[conn-1]),Mambo::AngularVelocity(path[conn-1],path[conn]));
            GlobalAngularVelocity[path[conn]][triad1]:=Mambo::MamboMult(-1,
              GlobalAngularVelocity[triad1][path[conn]]);
          end_if;
        end_for;
      end_if;
    end_if;
    return(GlobalAngularVelocity[triad1][triad2]);
  end_proc: