Mambo::GeomOut:=proc()
  local each,position,orientation,text_out;
  begin
    text_out:="";
    if args(0)=2 then 
      text_out:=_concat(text_out,"MODULE ",args(1)," {\n");
      for each in GlobalObjectDefinitions[args(1)] do 
        text_out:=_concat(text_out,Mambo::ObjectOutput(args(1),each,1,args(2)));
      end_for;
      for each in GlobalObserverDeclarations[args(1)] do 
        text_out:=_concat(text_out,Mambo::GeomOut(each,args(1),1,args(2)));
      end_for;
    elif args(0)=4 then
      text_out:=_concat(text_out,Mambo::DoIndent(args(3),"   "));
      text_out:=_concat(text_out,"BODY ",args(1)," {\n");
      position:=Mambo::PointOut(args(2),args(1));
      if position=`Null` then ;
      elif position=`Empty` then 
        text_out:=_concat(text_out,Mambo::DoIndent(args(3)+1,"   "));
        text_out:=_concat(text_out,"Point {}\n");
        if args(4)[1] then error("No path between reference points of observers ".args(1)." ".args(2)); end_if;
      else
        if args(4)[2] then Mambo::CheckArguments([position],args(4)[3]); end_if;
        text_out:=_concat(text_out,Mambo::DoIndent(args(3)+1,"   "));
        text_out:=_concat(text_out,"Point {",position[1],",",position[2],",",position[3],"}\n");
      end_if;
      orientation:=Mambo::OrientOut(args(2),args(1));
      if position=`Null` then ;
      elif orientation=`Empty` then
        text_out:=_concat(text_out,Mambo::DoIndent(args(3)+1,"   "));
        text_out:=_concat(text_out,"Orient {}\n");
        if args(4)[1] then error("No path between reference triads of observers ".args(1)." ".args(2)); end_if;
      else 
        if args(4)[2] then Mambo::CheckArguments([orientation],args(4)[3]); end_if;
        text_out:=_concat(text_out,Mambo::DoIndent(args(3)+1,"   "));
        text_out:=_concat(text_out,"Orient {",orientation[1],",",orientation[2],",",orientation[3],",",orientation[4],",",orientation[5],",",orientation[6],",",orientation[7],",",orientation[8],",",orientation[9],"}\n");
      end_if;
      for each in GlobalObjectDefinitions[args(1)] do 
        text_out:=_concat(text_out,Mambo::ObjectOutput(args(1),each,args(3)+1,args(4)));
      end_for;
      for each in GlobalObserverDeclarations[args(1)] minus {args(2)} do
        text_out:=_concat(text_out,Mambo::GeomOut(each,args(1),args(3)+1,args(4)));
      end_for;
      text_out:=_concat(text_out,Mambo::DoIndent(args(3),"   "));
    end_if;
    text_out:=_concat(text_out,"}\n");
    return(text_out);
  end_proc: