Mambo::MamboDot := proc(ev1:Type::Union(MamboVector,MamboDescription),ev2:Type::Union(MamboVector,MamboDescription))
  local result,i,j,k,rotation;
  begin
    if ev1["Type"]<>ev2["Type"] then error("Incompatible arguments!"); end_if;
      if testtype(ev1,MamboVector) then
        result:=matrix(1,1); 
        for i from 1 to ev1["Size"] do
          for j from 1 to ev2["Size"] do 
            rotation:=Mambo::FindRotation(ev1[i]["Triad"],ev2[j]["Triad"]);
            result:=result+transpose(ev1[i]["Coordinates"])*rotation*ev2[j]["Coordinates"];
          end_for;
        end_for;
        return(result[1,1]);
      else
        if ev1["Size"][2]<>ev2["Size"][1] then error("Incompatible arguments!"); end_if;
        result:=matrix(ev1["Size"][1],ev2["Size"][2]);
        for i from 1 to ev1["Size"][1] do
          for j from 1 to ev2["Size"][2] do
            for k from 1 to ev1["Size"][2] do
              result[i,j]:=result[i,j]+Mambo::MamboDot(ev1[i,k],ev2[k,j]);
            end_for;
          end_for;
        end_for;
        return(result);
      end_if;
    end_proc:
