Mambo::MotionOutput:=proc()
  local test,i,j,eqs,temps1,temps2,statement,A,B,breakpoint,
    tims,de,stas,staslist,substas,pars,parslist,subpars,inss,
    insslist,anislist,anis,vars,each,checkarg,checksing,fd,output_file,text_out;
  begin
    test:=proc(cond,out) begin if cond then return(out) end_if; end_proc;
    stas:={};pars:={};inss:={};anis:={};vars:={};tims:=`t`;de:={};
    staslist:={};parslist:={};insslist:={};anislist:={};
    output_file:=`terminal`;checkarg:=FALSE;checksing:=FALSE;
    if args(0)>1 then
      substas:={};
      subpars:={};
      for each in [args()] do
        if testtype(each,Type::Equation()) then
          LHS:=op(each,1);
          RHS:=op(each,2);
          case LHS
            of `ode` do
              if testtype(RHS,DOM_SET) then de:=RHS; end_if; break
            of `time` do
              if testtype(RHS,DOM_IDENT) then tims:=RHS; end_if; break
            of `states` do
              if testtype(RHS,Type::Union(Type::ListOf(Type::Union(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Numeric))),Type::SetOf(Type::Union(DOM_IDENT,Type::Equation(DOM_IDENT,Type::Numeric))))) then
                staslist := RHS;
                stas := {_seqgen(op(staslist[i],1),i,1..nops(staslist))};
                substas:={_seqgen(if testtype(staslist[i],Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Numeric)) then staslist[i]; else staslist[i]=0 end_if,i,1..nops(staslist))};
              end_if; break
            of `parameters` do
              if testtype(RHS,Type::Union(Type::ListOf(Type::Union(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Numeric))),Type::SetOf(Type::Union(DOM_IDENT,Type::Equation(DOM_IDENT,Type::Numeric))))) then
                parslist := RHS;
                pars := {_seqgen(op(parslist[i],1),i,1..nops(parslist))};
                subpars:={_seqgen(if testtype(parslist[i],Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Numeric)) then parslist[i]; else parslist[i]=0 end_if,i,1..nops(pars))};
              end_if; break
            of `insignals` do
              if testtype(RHS,Type::Union(Type::ListOf(Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Arithmetical)),Type::SetOf(Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Arithmetical)))) then
                insslist := RHS;
                inss := {_seqgen(op(insslist[i],1),i,1..nops(insslist))};
              end_if; break
            of `anims` do
              if testtype(RHS,Type::Union(Type::ListOf(Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Arithmetical)),Type::SetOf(Type::Equation(Type::Union(DOM_IDENT,DOM_FUNC_ENV),Type::Arithmetical)))) then            
                anislist := RHS;
                anis := {_seqgen(op(anislist[i],1),i,1..nops(anislist))};
              end_if; break
            of `filename` do
              if testtype(RHS,Type::Union(DOM_STRING)) or RHS=`terminal` then output_file:=RHS; end_if; break
            otherwise
          end_case;
        elif each=`checkargs` then checkarg:=TRUE;
        elif each=`checksings` then checksing:=TRUE; 
        else error("bad option ".each);
        end_if; 
      end_for;
      vars:={tims} union stas union pars union inss union anis union map(stas,_concat,t):
      if checkarg then
        Mambo::CheckArguments(de,vars);
        Mambo::CheckArguments(insslist,vars);
        Mambo::CheckArguments(anislist,vars);
      end_if;
    else error("Too few arguments!");
    end_if;
    if de<>{} then
      if nops(stas)<>nops(de) then error("Incompatible number of state variables!"); end_if;
      stas:=[op(stas)];
      A:=linalg::expr2Matrix(de,map(stas,_concat,t));
      B:=linalg::col(A,nops(stas)+1);
      A:=linalg::delCol(A,nops(stas)+1);
      if checksing then
        if linalg::det(simplify(subs(A,subpars,substas,tims=0)))=0 then error("Mass matrix initially singular!"); end_if;
      end_if;
      temps1:=map([_seqgen(_concat("rhs_",stas[i]),i,1..nops(stas))],coerce,DOM_IDENT);
      temps2:=map(matrix([_seqgen([_seqgen(_concat("mass_",stas[i],"_",stas[j]),j,1..nops(stas))],i,1..nops(stas))]),coerce,DOM_IDENT);
      eqs:=[_seqgen(test(B[i]<>0,temps1[i]=B[i]),i,1..nops(stas)),
            _seqgen(_seqgen(test(A[i,j]<>0,temps2[i,j]=A[i,j]),i,1..nops(stas)),j,1..nops(stas))];
      eqs:=map(generate::optimize(eqs),coerce,DOM_STRING):
        end_if;
    text_out:="";
    if nops(staslist)>0 then
      text_out:="states "; 
      for i from 1 to nops(staslist)-1 do text_out:=_concat(text_out,staslist[i],","); end_for;
      text_out:=_concat(text_out,staslist[nops(staslist)],";\n");
    end_if;
    if nops(parslist)>0 then
      text_out:=_concat(text_out,"parameters "); 
      for i from 1 to nops(parslist)-1 do text_out:=_concat(text_out,parslist[i],","); end_for;
      text_out:=_concat(text_out,parslist[nops(parslist)],";\n");
    end_if;
    if has(de,tims) or has(insslist,tims) or has(anislist,tims) then
      text_out:=_concat(text_out,"time ",tims,";\n\n");
    end_if;
    if nops(anislist)>0 then
      text_out:=_concat(text_out,"anims {\n");
      for i from 1 to nops(anislist) do
        temp:=coerce(anislist[i],DOM_STRING);
        temp:=Mambo::InEq("LT",temp,"<");
        temp:=Mambo::InEq("LTE",temp,"<=");
        temp:=Mambo::InEq("GT",temp,">");
        temp:=Mambo::InEq("GTE",temp,">=");
        temp:=Mambo::InEq("NE",temp,"!=");
        temp:=Mambo::InEq("E",temp,"==");
        text_out:=_concat(text_out,"    ",temp,";\n");
      end_for;
      text_out:=_concat(text_out,"}\n\n");
    end_if;
    if nops(de)>0 then
        text_out:=_concat(text_out,"insignals {\n");
        for i from 1 to nops(insslist) do
          temp:=coerce(insslist[i],DOM_STRING);
          temp:=Mambo::InEq("LT",temp,"<");
          temp:=Mambo::InEq("LTE",temp,"<=");
          temp:=Mambo::InEq("GT",temp,">");
          temp:=Mambo::InEq("GTE",temp,">=");
          temp:=Mambo::InEq("NE",temp,"!=");
          temp:=Mambo::InEq("E",temp,"==");
          text_out:=_concat(text_out,"    ",temp,";\n");
        end_for;
        for i from 1 to nops(eqs) do
          text_out:=_concat(text_out,"    ",coerce(eqs[i],DOM_STRING),";\n");
        end_for;
        text_out:=_concat(text_out,"}\n\n");
      text_out:=_concat(text_out,"ode {\n");
      for i from 1 to nops(stas) do
        if B[i]<>0 then
          text_out:=_concat(text_out,"    ",coerce(rhs[stas[i]]=temps1[i],DOM_STRING),";\n");
        end_if;
      end_for;
      for i from 1 to nops(stas) do
        for j from 1 to nops(stas) do
          if A[i,j]<>0 then
            text_out:=_concat(text_out,"    ",coerce(mass[stas[i]][stas[j]]=temps2[i,j],DOM_STRING),";\n");
          end_if;
        end_for;
      end_for;
      text_out:=_concat(text_out,"}\n");
    end_if; 
    if output_file=`terminal` then
      print(Unquoted,text_out);
    else
      fd:=fopen(output_file,Write,Text);
      fprint(Unquoted,NoNL,fd,text_out);
      fclose(fd);
    end_if;
  end_proc: