Mambo::ObjectOutput:=proc(root,object,indent)
  local nopath,i,j,k,text_out,temp;
  begin
    text_out:="";
    text_out:=_concat(text_out,Mambo::DoIndent(indent,"   "));
    text_out:=_concat(text_out,object["Type"]," {\n");
    if contains(object,"Point") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if object["Point"]["Size"]=0 then
        text_out:=_concat(text_out,"Point{0,0,0}\n");
      else
        nopath:=FALSE;
        for i from 1 to object["Point"]["Size"] do
          if nops(Mambo::FindPath(GlobalObserverDefinitions[root]["Triad"],object["Point"][i]["Triad"],GlobalTriadDeclarations))=0 then
            nopath:=TRUE;
          end_if;
        end_for;
        if nopath then 
          text_out:=cat(text_out,"Point {}\n");  
          if args(4)[1] then error("No path from reference triad of parent observer to object's point vector!"); end_if;
        else
          temp:=_seqgen(Mambo::MamboDot(object["Point"],Mambo::_MakeTranslation(GlobalObserverDefinitions[root]["Triad"],j)),j,1..3);
          if args(4)[2] then Mambo::CheckArguments([temp],args(4)[3]); end_if;
          text_out:=_concat(text_out,"Point {",temp[1],",",temp[2],",",temp[3],"}\n"); 
        end_if;
      end_if;
    end_if;
    if contains(object,"Orient") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      temp:=_seqgen(_seqgen(object["Orient"][j,k],k,1..3),j,1..3);
      if args(4)[2] then Mambo::CheckArguments([temp],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Orient{",temp[1],",",temp[2],",",temp[3],",",temp[4],",",temp[5],",",temp[6],",",temp[7],",",temp[8],",",temp[9],"}\n");
    end_if;
    if contains(object,"Radius") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if args(4)[2] then Mambo::CheckArguments(object["Radius"],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Radius ",object["Radius"],"\n");
    end_if;
    if contains(object,"Length") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if args(4)[2] then Mambo::CheckArguments(object["Length"],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Length ",object["Length"],"\n");
    end_if;
    if contains(object,"Xlength") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if args(4)[2] then Mambo::CheckArguments(object["Xlength"],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Xlength ",object["Xlength"],"\n");
    end_if;
    if contains(object,"Ylength") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if args(4)[2] then Mambo::CheckArguments(object["Ylength"],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Ylength ",object["Ylength"],"\n");
    end_if;
    if contains(object,"Zlength") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if args(4)[2] then Mambo::CheckArguments(object["Zlength"],args(4)[3]); end_if;
      text_out:=_concat(text_out,"Zlength ",object["Zlength"],"\n");
    end_if;
    if contains(object,"Color") then
      text_out:=_concat(text_out,Mambo::DoIndent(indent+1,"   "));
      if object["Color"]=red then text_out:=_concat(text_out,"Color {1,0,0}\n");
      elif object["Color"]=green then text_out:=_concat(text_out,"Color {0,1,0}\n");
      elif object["Color"]=blue then text_out:=_concat(text_out,"Color {0,0,1}\n");
      elif object["Color"]=yellow then text_out:=_concat(text_out,"Color {1,1,0}\n");
      elif object["Color"]=magenta then text_out:=_concat(text_out,"Color {1,0,1}\n");
      elif object["Color"]=cyan then text_out:=_concat(text_out,"Color {0,1,1}\n");
      elif object["Color"]=white then text_out:=_concat(text_out,"Color {1,1,1}\n");
      elif object["Color"]=black then text_out:=_concat(text_out,"Color {0,0,0}\n");
      else
        if args(4)[2] then Mambo::CheckArguments(coerce(object["Color"],DOM_EXPR),args(4)[3]); end_if;
        text_out:=_concat(text_out,"Color ",object["Color"],"\n");
      end_if;
    end_if;
    text_out:=_concat(text_out,Mambo::DoIndent(indent,"   "));
    text_out:=_concat(text_out,"}\n");
    return(text_out);
  end_proc: