Mambo::_DefineObject:=proc(observer,object_type)
  local object,each,LHS,RHS;
  begin
    if Mambo::IsDefined(observer,`Observer`) then
      object["Type"]:=object_type;
      for each in [args(3..args(0))] do
        if testtype(each,Type::Equation()) then
          LHS:=op(each,1);
          RHS:=op(each,2);
          case LHS
            of `point` do
              if testtype(RHS,MamboVector) then 
                object["Point"]:=RHS;
              elif testtype(RHS,DOM_IDENT) then
                 if Mambo::IsDeclared(RHS,`Point`) then
                   object["Point"]:=Mambo::FindTranslation(GlobalObserverDefinitions[observer]["Point"],RHS);
                 else error("No path from observer to point ".RHS);
                 end_if;
              end_if; break
            of `orient` do
              if testtype(RHS,Dom::Matrix()) and linalg::ncols(RHS)=3 and linalg::nrows(RHS)=3 then
                object["Orient"]:=RHS;
              elif testtype(RHS,DOM_IDENT) then
                if Mambo::IsDeclared(RHS,`Triad`) then
                  object["Orient"]:=Mambo::FindRotation(GlobalObserverDefinitions[observer]["Triad"],RHS);
                else error("No path from observer to triad ".RHS);
                end_if;
              end_if; break
            of `radius`do
              if object_type=`Sphere` or object_type=`Cylinder` then object["Radius"]:=RHS; end_if; break
            of `length` do
              if object_type=`Cylinder` then object["Length"]:=RHS; end_if; break
            of `xlength` do
              if object_type=`Block` then object["Xlength"]:=RHS; end_if; break
            of `ylength` do
              if object_type=`Block` then object["Ylength"]:=RHS; end_if; break
            of `zlength` do
              if object_type=`Block` then object["Zlength"]:=RHS; end_if; break
            of `color` do
              if testtype(RHS,DOM_STRING) or testtype(RHS,DOM_IDENT) then object["Color"]:=RHS; end_if; break
            otherwise
              error("Unrecognized property for object !".k." ".object_type);
          end_case;
        end_if;
      end_for;
      GlobalObjectDefinitions[observer]:=[op(GlobalObjectDefinitions[observer]),object];
    else
      error("Observer not defined! ".observer);
    end_if;
    return("Done!");
  end_proc: